package org.vtokarev.controller;

import org.vtokarev.domain.Room;
import org.vtokarev.domain.RoomClass;
import org.vtokarev.service.RoomClassService;
import org.vtokarev.service.RoomService;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.net.URLEncoder;
import java.nio.charset.StandardCharsets;
import java.util.List;
import java.util.Optional;

/**
 * {@code ModifyRoomServlet} class uses for create, edit and delete rooms.
 * It implements {@code doGet} method that processes GET {@code modifyRoom} requests generated by users with ADMIN role.
 * In the {@code doGet} method, it collects the necessary data from the ADMIN request and forwards them to {@code modifyRoom.jsp} view for further processing.
 *
 *  In the {@code doPost} method it implements create, edit, and delete room operations. After the operation is completed it forwards the control to {@code roomList}.
 *
 * @author Vyacheslav Tokarev
 */

@WebServlet(urlPatterns = "/modifyRoom", name = "modifyRoomServlet")
public class ModifyRoomServlet extends HttpServlet {

    private RoomService roomService;
    private RoomClassService roomClassService;

    @Override
    public void init(ServletConfig config) throws ServletException {
        roomService = (RoomService) config.getServletContext().getAttribute("app/RoomService");
        roomClassService = (RoomClassService) config.getServletContext().getAttribute("app/RoomClassService");
    }

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        if (req.getParameter("action") == null || req.getParameter("back") == null) {
            resp.sendRedirect("home");
            return;
        }

        if (req.getParameter("action").equals("edit") && req.getParameter("roomId") == null) {
            resp.sendRedirect("home");
            return;
        }

        List<RoomClass> roomClasses = roomClassService.getAll();
        req.setAttribute("roomClasses", roomClasses);

        if ("create".equals(req.getParameter("action"))) {

            req.setAttribute("action", "create");

            if (req.getParameter("roomNumber") != null) {
                req.setAttribute("roomNumber", req.getParameter("roomNumber"));
            }

            if (req.getParameter("roomName") != null) {
                req.setAttribute("roomName", req.getParameter("roomName"));
            }
            if (req.getParameter("capacity") != null) {
                req.setAttribute("capacity", req.getParameter("capacity"));
            }
            if (req.getParameter("roomClassName") != null) {
                req.setAttribute("roomClassName", req.getParameter("roomClassName"));
            }
            if (req.getParameter("roomClassId") != null) {
                req.setAttribute("roomClassId", req.getParameter("roomClassId"));
            }
            if (req.getParameter("price") != null) {
                req.setAttribute("price", req.getParameter("price"));
            }
            if (req.getParameter("description") != null) {
                req.setAttribute("description", req.getParameter("description"));
            }
            if (req.getParameter("available") != null) {
                req.setAttribute("available", req.getParameter("available"));
            }
            if (req.getParameter("errorMessage") != null) {
                req.setAttribute("errorMessage", req.getParameter("errorMessage"));
            }

        } else if ("edit".equals(req.getParameter("action"))) {
            long roomId;
            try {
                roomId = Long.parseLong(req.getParameter("roomId"));
            } catch (NumberFormatException e) {
                resp.sendRedirect("home");
                return;
            }
            Optional<Room> room = roomService.getRoomById(roomId);

            if (room.isEmpty() || roomClasses.isEmpty()) {
                resp.sendRedirect("home");
                return;
            }

            req.setAttribute("action", "edit");
            req.setAttribute("roomId", room.get().getId());
            req.setAttribute("roomNumber", req.getParameter("errorMessage") != null ? req.getParameter("roomNumber") : room.get().getNumber());
            req.setAttribute("capacity", req.getParameter("errorMessage") != null ? Integer.parseInt(req.getParameter("capacity")) : room.get().getCapacity());
            req.setAttribute("roomName", req.getParameter("errorMessage") != null ? req.getParameter("roomName") : room.get().getName());
            req.setAttribute("roomClassId", req.getParameter("errorMessage") != null ? Long.parseLong(req.getParameter("roomClassId")) : room.get().getRoomClassId());
            req.setAttribute("price", req.getParameter("errorMessage") != null ? Double.parseDouble(req.getParameter("price")) : room.get().getPrice());
            req.setAttribute("description", req.getParameter("errorMessage") != null ? req.getParameter("description") : room.get().getDescription());
            req.setAttribute("available", req.getParameter("errorMessage") != null ? "true".equals(req.getParameter("available")) : room.get().isAvailable());

            if (req.getParameter("errorMessage") != null)
                req.setAttribute("errorMessage", req.getParameter("errorMessage"));

        }
        req.setAttribute("back", req.getParameter("back"));
        req.getRequestDispatcher("/WEB-INF/jsp/modifyRoom.jsp").forward(req, resp);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws IOException {
        String action;
        long roomId = 0;
        String roomName = "";
        String roomNumber = "";
        int capacity = 0;
        long roomClassId = 0;
        double price = 0.0;
        String description = "";
        boolean available;
        String errorMessage;
        String requestStr;

        try {
            action = req.getParameter("action");

            if("edit".equals(action) || "delete".equals(action)) {
                roomId = Long.parseLong(req.getParameter("roomId"));
            }

            if(req.getParameter("roomNumber") != null) {
                roomNumber = req.getParameter("roomNumber");
            }

            if(req.getParameter("roomName") != null) {
                roomName = req.getParameter("roomName");
            }

            if(req.getParameter("capacity") != null) {
                capacity = Integer.parseInt(req.getParameter("capacity"));
            }

            if(req.getParameter("roomClassId") != null) {
                roomClassId = Long.parseLong(req.getParameter("roomClassId"));
            }

            if(req.getParameter("price") != null) {
                price = Double.parseDouble(req.getParameter("price"));
            }

            if(req.getParameter("description") != null) {
                description = req.getParameter("description");
            }

            available = "on".equals(req.getParameter("available"));
        } catch (NumberFormatException e) {
            resp.sendRedirect("home");
            return;
        }
        if ("delete".equals(action)) {
            roomService.delete(Long.parseLong(req.getParameter("roomId")));
            resp.sendRedirect("roomList");
        } else if ("edit".equals(action)) {
            errorMessage = roomService.getEditErrorMessage(roomId, roomNumber);

            if (errorMessage.isBlank()) {
                Room room = new Room(roomId, roomName, roomNumber, capacity, roomClassId, description,
                        price, available);
                roomService.update(room);
                resp.sendRedirect("roomList");
            } else {
                requestStr = "?action=edit&back=roomList&roomId=" + roomId +
                        "&roomNumber=" + URLEncoder.encode(roomNumber, StandardCharsets.UTF_8) + "&roomName=" + URLEncoder.encode(roomName, StandardCharsets.UTF_8) +
                        "&capacity=" + capacity + "&roomClassId=" + roomClassId +
                        "&price=" + price + "&description=" + URLEncoder.encode(description, StandardCharsets.UTF_8) +
                        "&available=" + available + "&errorMessage=" + errorMessage;
                resp.sendRedirect("modifyRoom" + requestStr);
            }

        } else if ("create".equals(action)) {
            errorMessage = roomService.getCreateErrorMessage(roomNumber);

            if (errorMessage.isBlank()) {
                Room room = new Room(0, roomName, roomNumber, capacity, roomClassId, description,
                         price, available);

                roomService.create(room);
                resp.sendRedirect("roomList");
            } else {
                requestStr = "?action=create&back=roomList&roomId=" + roomId +
                        "&roomNumber=" + URLEncoder.encode(roomNumber, StandardCharsets.UTF_8) + "&roomName=" + URLEncoder.encode(roomName, StandardCharsets.UTF_8) +
                        "&capacity=" + capacity + "&roomClassId=" + roomClassId +
                        "&price=" + price + "&description=" + URLEncoder.encode(description, StandardCharsets.UTF_8) +
                        "&available=" + available + "&errorMessage=" + errorMessage;
                resp.sendRedirect("modifyRoom" + requestStr);
            }
        }
    }
}